<!--
	This component takes care of drawing the plotting frame and frame annotation,
	as well as setting up the clippign mask per SubplotGroup. The actual plot
	elements will be included in the slot.
-->
<script>
    import { layout } from "../svelte_stores/layout_store";
    import { timeDomain } from "../svelte_stores/timedomain_store";
    import SubplotXAxis from "./plot_frame_components/SubplotXAxis.svelte";
    import SubplotYAxis from "./plot_frame_components/SubplotYAxis.svelte";
    import NowIndicator from "./plot_frame_components/NowIndicator.svelte";
    import FrameLabel from "./plot_frame_components/FrameLabel.svelte";
    import Legend from "./plot_frame_components/Legend.svelte";
    import OptionalAnnotationBackground from "./plot_frame_components/OptionalAnnotationBackground.svelte";
    import OptionalAnnotationForeground from "./plot_frame_components/OptionalAnnotationForeground.svelte";

    export let subplot;
    export let xScale;

    let clip_path_url = "url(#clip_subplot_" + subplot.computed.id + ")";
</script>

{#if subplot.annot_options}
    <OptionalAnnotationBackground {subplot} {xScale} {clip_path_url} />
{/if}
<slot />
<slot name="not_clipped" />
<slot name="clipped" />
<SubplotXAxis {subplot} {xScale} />
<SubplotYAxis {subplot} {xScale} />
{#if subplot.annot_options}
    <OptionalAnnotationForeground {subplot} {xScale} {clip_path_url} />
{/if}

<NowIndicator
    {xScale}
    y1={subplot.computed.y}
    y2={subplot.computed.y + subplot.computed.h}
    {clip_path_url} />
<FrameLabel {subplot} {xScale} />
{#if subplot.legend_visible}
    <Legend bind:subplot {xScale} />
{/if}

<style>
</style>
